(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core')) :
	typeof define === 'function' && define.amd ? define('angular-gamification', ['exports', '@angular/core'], factory) :
	(factory((global.ng = global.ng || {}, global.ng.angularGamification = {}),global.ng.core));
}(this, (function (exports,core) { 'use strict';

/**
 * @license angular-gamification
 * MIT license
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var MissionService = (function () {
    function MissionService(name, points, description, startFn, achieveFn) {
        this.name = 'Mission';
        this.points = 0;
        this.description = '';
        this.startFn = function () { };
        this.achieveFn = function () { };
        this.name = name;
        this.points = points;
        this.description = description || this.description;
        this.startFn = startFn || this.startFn;
        this.achieveFn = achieveFn || this.achieveFn;
    }
    /**
     * @param {?} points
     * @return {?}
     */
    MissionService.prototype.setPoints = /**
     * @param {?} points
     * @return {?}
     */
    function (points) {
        this.points = points;
    };
    /**
     * @return {?}
     */
    MissionService.prototype.start = /**
     * @return {?}
     */
    function () {
        this.startFn();
    };
    /**
     * @param {?} report
     * @return {?}
     */
    MissionService.prototype.achieve = /**
     * @param {?} report
     * @return {?}
     */
    function (report) {
        this.achieveFn(report);
    };
    MissionService.decorators = [
        { type: core.Injectable },
    ];
    /** @nocollapse */
    MissionService.ctorParameters = function () { return [
        null,
        null,
        null,
        { type: Function, },
        { type: Function, },
    ]; };
    return MissionService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ProgressBarService = (function () {
    function ProgressBarService(maxPoints, updateFn, startFn) {
        this.maxPoints = 0;
        this.updateFn = function () { };
        this.startFn = function () { };
        this.maxPoints = maxPoints || this.maxPoints;
        this.updateFn = updateFn || this.updateFn;
        this.startFn = startFn || this.startFn;
        this.isFull = false;
        // return this;
    }
    /**
     * @param {?} points
     * @return {?}
     */
    ProgressBarService.prototype.update = /**
     * @param {?} points
     * @return {?}
     */
    function (points) {
        if (!this.isFull) {
            this.updateFn();
            if (this.maxPoints <= points) {
                this.isFull = true;
            }
        }
    };
    /**
     * @return {?}
     */
    ProgressBarService.prototype.start = /**
     * @return {?}
     */
    function () {
        this.startFn(this.maxPoints);
    };
    /**
     * @param {?} points
     * @return {?}
     */
    ProgressBarService.prototype.getProgress = /**
     * @param {?} points
     * @return {?}
     */
    function (points) {
        return Math.min(Math.max(Math.ceil(100 * points / this.maxPoints), 0), 100);
    };
    ProgressBarService.decorators = [
        { type: core.Injectable },
    ];
    /** @nocollapse */
    ProgressBarService.ctorParameters = function () { return [
        null,
        { type: Function, },
        { type: Function, },
    ]; };
    return ProgressBarService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var BreakpointService = (function () {
    function BreakpointService(pointsThreshold, action) {
        this.actionFunc = function () { };
        this.pointsThreshold = pointsThreshold;
        this.actionFunc = action || this.actionFunc;
    }
    /**
     * @return {?}
     */
    BreakpointService.prototype.action = /**
     * @return {?}
     */
    function () {
        this.actionFunc();
    };
    BreakpointService.decorators = [
        { type: core.Injectable },
    ];
    /** @nocollapse */
    BreakpointService.ctorParameters = function () { return [
        null,
        { type: Function, },
    ]; };
    return BreakpointService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ReportService = (function () {
    function ReportService() {
        this.reports = [];
    }
    /**
     * @param {?} reports
     * @return {?}
     */
    ReportService.prototype.set = /**
     * @param {?} reports
     * @return {?}
     */
    function (reports) {
        this.reports = reports;
    };
    /**
     * @param {?} report
     * @return {?}
     */
    ReportService.prototype.add = /**
     * @param {?} report
     * @return {?}
     */
    function (report) {
        this.reports.push(report);
        return report;
    };
    /**
     * @return {?}
     */
    ReportService.prototype.get = /**
     * @return {?}
     */
    function () {
        return /** @type {?} */ (this.reports);
    };
    /**
     * @return {?}
     */
    ReportService.prototype.clear = /**
     * @return {?}
     */
    function () {
        this.reports = [];
    };
    ReportService.decorators = [
        { type: core.Injectable },
    ];
    /** @nocollapse */
    ReportService.ctorParameters = function () { return []; };
    return ReportService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var GamificationService = (function () {
    function GamificationService(config) {
        this.config = config;
        this.points = 0;
        this.levels = [];
        this.breakpoints = Array();
        this.missions = Array();
        this.components = Array();
        this.reportService = new ReportService();
        this.levels = config.levels || this.levels;
        this.level = config.level || this.levels[0];
        this.points = config.points || this.points;
    }
    /**
     * @param {?} points
     * @param {?=} updateFn
     * @param {?=} startFn
     * @return {?}
     */
    GamificationService.prototype.addComponent = /**
     * @param {?} points
     * @param {?=} updateFn
     * @param {?=} startFn
     * @return {?}
     */
    function (points, updateFn, startFn) {
        var /** @type {?} */ component = new ProgressBarService(points, updateFn, startFn);
        this.components.push(component);
        component.start();
        return component;
    };
    /**
     * @return {?}
     */
    GamificationService.prototype.getComponents = /**
     * @return {?}
     */
    function () {
        return this.components;
    };
    /**
     * @param {?} name
     * @param {?} points
     * @param {?=} description
     * @param {?=} startFn
     * @param {?=} achieveFn
     * @return {?}
     */
    GamificationService.prototype.addMission = /**
     * @param {?} name
     * @param {?} points
     * @param {?=} description
     * @param {?=} startFn
     * @param {?=} achieveFn
     * @return {?}
     */
    function (name, points, description, startFn, achieveFn) {
        var /** @type {?} */ mission = new MissionService(name, points, description, startFn, achieveFn);
        this.missions.push(mission);
        mission.start();
        return mission.name;
    };
    /**
     * @return {?}
     */
    GamificationService.prototype.getMissions = /**
     * @return {?}
     */
    function () {
        return this.missions;
    };
    /**
     * @param {?} points
     * @param {?=} actionFn
     * @return {?}
     */
    GamificationService.prototype.addBreakpoint = /**
     * @param {?} points
     * @param {?=} actionFn
     * @return {?}
     */
    function (points, actionFn) {
        var /** @type {?} */ breakpoint = new BreakpointService(points, actionFn);
        this.breakpoints.push(breakpoint);
    };
    /**
     * @return {?}
     */
    GamificationService.prototype.getBreakpoints = /**
     * @return {?}
     */
    function () {
        return this.breakpoints;
    };
    /**
     * @param {?} points
     * @return {?}
     */
    GamificationService.prototype.addPoints = /**
     * @param {?} points
     * @return {?}
     */
    function (points) {
        var _this = this;
        this.points += points;
        this.breakpoints.forEach(function (breakpoint, index) {
            if (((_this.points - points) < _this.breakpoints[index].pointsThreshold) && (_this.breakpoints[index].pointsThreshold <= (_this.points))) {
                _this.breakpoints[index].action();
            }
        });
        this.components.forEach(function (component, index) {
            _this.components[index].update(points);
        });
    };
    /**
     * @return {?}
     */
    GamificationService.prototype.getPoints = /**
     * @return {?}
     */
    function () {
        return this.points;
    };
    /**
     * @param {?} points
     * @return {?}
     */
    GamificationService.prototype.setPoints = /**
     * @param {?} points
     * @return {?}
     */
    function (points) {
        this.points = points;
    };
    /**
     * @param {?} levels
     * @return {?}
     */
    GamificationService.prototype.setLevels = /**
     * @param {?} levels
     * @return {?}
     */
    function (levels) {
        this.levels = levels;
    };
    /**
     * @return {?}
     */
    GamificationService.prototype.getLevels = /**
     * @return {?}
     */
    function () {
        return this.levels;
    };
    /**
     * @param {?} level
     * @return {?}
     */
    GamificationService.prototype.addLevel = /**
     * @param {?} level
     * @return {?}
     */
    function (level) {
        this.levels.push(level);
    };
    /**
     * @param {?} level
     * @return {?}
     */
    GamificationService.prototype.setLevel = /**
     * @param {?} level
     * @return {?}
     */
    function (level) {
        this.level = level;
    };
    /**
     * @return {?}
     */
    GamificationService.prototype.getLevel = /**
     * @return {?}
     */
    function () {
        return this.level;
    };
    /**
     * @param {?} points
     * @return {?}
     */
    GamificationService.prototype.getLevelByPoints = /**
     * @param {?} points
     * @return {?}
     */
    function (points) {
        return this.getLevels().filter(function (level) {
            if (level.range) {
                return (level.range.min <= points) && (level.range.max >= points);
            }
        }, this.setLevel)[0];
    };
    /**
     * @param {?} reports
     * @return {?}
     */
    GamificationService.prototype.setReports = /**
     * @param {?} reports
     * @return {?}
     */
    function (reports) {
        this.reportService.set(reports);
    };
    /**
     * @return {?}
     */
    GamificationService.prototype.getReports = /**
     * @return {?}
     */
    function () {
        return this.reportService.get();
    };
    /**
     * @return {?}
     */
    GamificationService.prototype.clearReport = /**
     * @return {?}
     */
    function () {
        this.reportService.clear();
    };
    /**
     * @param {?} name
     * @return {?}
     */
    GamificationService.prototype.achieveMission = /**
     * @param {?} name
     * @return {?}
     */
    function (name) {
        var _this = this;
        this.missions.map(function (mission, index) {
            if (mission.name === name) {
                _this.addPoints(mission.points);
                var /** @type {?} */ report = _this.reportService.add({
                    description: mission.description,
                    points: mission.points
                });
                mission.achieve(report);
            }
        });
    };
    GamificationService.decorators = [
        { type: core.Injectable },
    ];
    /** @nocollapse */
    GamificationService.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: core.Inject, args: ['config',] },] },
    ]; };
    return GamificationService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
// Consider registering providers using a forRoot() method
// when the module exports components, directives or pipes that require sharing the same providers instances.
// Consider registering providers also using a forChild() method
// when they requires new providers instances or different providers in child modules.
var GamificationModule = (function () {
    function GamificationModule() {
    }
    /**
     * Use in AppModule: new instance of GamificationService.
     * @param {?=} config
     * @return {?}
     */
    GamificationModule.forRoot = /**
     * Use in AppModule: new instance of GamificationService.
     * @param {?=} config
     * @return {?}
     */
    function (config) {
        return {
            ngModule: GamificationModule,
            providers: [
                GamificationService,
                {
                    provide: 'config', useValue: config
                }
                // {
                //   provide: GamificationService, useValue: config, useClass: GamificationModule.forRoot(config)
                // }
            ]
        };
    };
    /**
     * Use in features modules with lazy loading: new instance of GamificationService.
     * @param {?=} config
     * @return {?}
     */
    GamificationModule.forChild = /**
     * Use in features modules with lazy loading: new instance of GamificationService.
     * @param {?=} config
     * @return {?}
     */
    function (config) {
        return {
            ngModule: GamificationModule,
            providers: [
                GamificationService,
                {
                    provide: 'config', useValue: config
                }
                // GamificationService,
                // {
                //   provide: GamificationService, useValue: config, useClass: GamificationService
                // }
            ]
        };
    };
    GamificationModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [],
                    exports: []
                },] },
    ];
    /** @nocollapse */
    GamificationModule.ctorParameters = function () { return []; };
    return GamificationModule;
}());

exports.GamificationService = GamificationService;
exports.GamificationModule = GamificationModule;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=angular-gamification.umd.js.map
