import { MissionService } from './mission.service';
import { ProgressBarService } from './progress-bar.service';
import { BreakpointService } from './breakpoint.service';
import { ReportService } from './report.service';
import { Level } from '../interface/level.interface';
import { Report } from '../interface/report.interface';
export declare class GamificationService {
    private config;
    points: number;
    levels: Array<Level>;
    level: Level;
    breakpoints: BreakpointService[];
    missions: MissionService[];
    components: ProgressBarService[];
    reportService: ReportService;
    constructor(config: any);
    addComponent(points: number, updateFn?: Function, startFn?: Function): ProgressBarService;
    getComponents(): ProgressBarService[];
    addMission(name: string, points: number, description?: string, startFn?: Function, achieveFn?: Function): string;
    getMissions(): MissionService[];
    addBreakpoint(points: number, actionFn?: Function): void;
    getBreakpoints(): BreakpointService[];
    addPoints(points: number): void;
    getPoints(): number;
    setPoints(points: number): void;
    setLevels(levels: Level[]): void;
    getLevels(): Level[];
    addLevel(level: Level): void;
    setLevel(level: Level): void;
    getLevel(): Level;
    getLevelByPoints(points: number): Level;
    setReports(reports: Report[]): void;
    getReports(): Report[];
    clearReport(): void;
    achieveMission(name: string): void;
}
