!function(global,factory){"object"==typeof exports&&"undefined"!=typeof module?factory(exports,require("@angular/core")):"function"==typeof define&&define.amd?define("angular-gamification",["exports","@angular/core"],factory):factory((global.ng=global.ng||{},global.ng.angularGamification={}),global.ng.core)}(this,function(exports,core){"use strict";/**
 * @license angular-gamification
 * MIT license
 */
var MissionService=function(){function MissionService(name,points,description,startFn,achieveFn){this.name="Mission",this.points=0,this.description="",this.startFn=function(){},this.achieveFn=function(){},this.name=name,this.points=points,this.description=description||this.description,this.startFn=startFn||this.startFn,this.achieveFn=achieveFn||this.achieveFn}return MissionService.prototype.setPoints=function(points){this.points=points},MissionService.prototype.start=function(){this.startFn()},MissionService.prototype.achieve=function(report){this.achieveFn(report)},MissionService.decorators=[{type:core.Injectable}],MissionService.ctorParameters=function(){return[null,null,null,{type:Function},{type:Function}]},MissionService}(),ProgressBarService=function(){function ProgressBarService(maxPoints,updateFn,startFn){this.maxPoints=0,this.updateFn=function(){},this.startFn=function(){},this.maxPoints=maxPoints||this.maxPoints,this.updateFn=updateFn||this.updateFn,this.startFn=startFn||this.startFn,this.isFull=!1}return ProgressBarService.prototype.update=function(points){this.isFull||(this.updateFn(),this.maxPoints<=points&&(this.isFull=!0))},ProgressBarService.prototype.start=function(){this.startFn(this.maxPoints)},ProgressBarService.prototype.getProgress=function(points){return Math.min(Math.max(Math.ceil(100*points/this.maxPoints),0),100)},ProgressBarService.decorators=[{type:core.Injectable}],ProgressBarService.ctorParameters=function(){return[null,{type:Function},{type:Function}]},ProgressBarService}(),BreakpointService=function(){function BreakpointService(pointsThreshold,action){this.actionFunc=function(){},this.pointsThreshold=pointsThreshold,this.actionFunc=action||this.actionFunc}return BreakpointService.prototype.action=function(){this.actionFunc()},BreakpointService.decorators=[{type:core.Injectable}],BreakpointService.ctorParameters=function(){return[null,{type:Function}]},BreakpointService}(),ReportService=function(){function ReportService(){this.reports=[]}return ReportService.prototype.set=function(reports){this.reports=reports},ReportService.prototype.add=function(report){return this.reports.push(report),report},ReportService.prototype.get=function(){return this.reports},ReportService.prototype.clear=function(){this.reports=[]},ReportService.decorators=[{type:core.Injectable}],ReportService.ctorParameters=function(){return[]},ReportService}(),GamificationService=function(){function GamificationService(config){this.config=config,this.points=0,this.levels=[],this.breakpoints=Array(),this.missions=Array(),this.components=Array(),this.reportService=new ReportService,this.levels=config.levels||this.levels,this.level=config.level||this.levels[0],this.points=config.points||this.points}return GamificationService.prototype.addComponent=function(points,updateFn,startFn){var component=new ProgressBarService(points,updateFn,startFn);return this.components.push(component),component.start(),component},GamificationService.prototype.getComponents=function(){return this.components},GamificationService.prototype.addMission=function(name,points,description,startFn,achieveFn){var mission=new MissionService(name,points,description,startFn,achieveFn);return this.missions.push(mission),mission.start(),mission.name},GamificationService.prototype.getMissions=function(){return this.missions},GamificationService.prototype.addBreakpoint=function(points,actionFn){var breakpoint=new BreakpointService(points,actionFn);this.breakpoints.push(breakpoint)},GamificationService.prototype.getBreakpoints=function(){return this.breakpoints},GamificationService.prototype.addPoints=function(points){var _this=this;this.points+=points,this.breakpoints.forEach(function(breakpoint,index){_this.points-points<_this.breakpoints[index].pointsThreshold&&_this.breakpoints[index].pointsThreshold<=_this.points&&_this.breakpoints[index].action()}),this.components.forEach(function(component,index){_this.components[index].update(points)})},GamificationService.prototype.getPoints=function(){return this.points},GamificationService.prototype.setPoints=function(points){this.points=points},GamificationService.prototype.setLevels=function(levels){this.levels=levels},GamificationService.prototype.getLevels=function(){return this.levels},GamificationService.prototype.addLevel=function(level){this.levels.push(level)},GamificationService.prototype.setLevel=function(level){this.level=level},GamificationService.prototype.getLevel=function(){return this.level},GamificationService.prototype.getLevelByPoints=function(points){return this.getLevels().filter(function(level){if(level.range)return level.range.min<=points&&level.range.max>=points},this.setLevel)[0]},GamificationService.prototype.setReports=function(reports){this.reportService.set(reports)},GamificationService.prototype.getReports=function(){return this.reportService.get()},GamificationService.prototype.clearReport=function(){this.reportService.clear()},GamificationService.prototype.achieveMission=function(name){var _this=this;this.missions.map(function(mission,index){if(mission.name===name){_this.addPoints(mission.points);var report=_this.reportService.add({description:mission.description,points:mission.points});mission.achieve(report)}})},GamificationService.decorators=[{type:core.Injectable}],GamificationService.ctorParameters=function(){return[{type:void 0,decorators:[{type:core.Inject,args:["config"]}]}]},GamificationService}(),GamificationModule=function(){function GamificationModule(){}return GamificationModule.forRoot=function(config){return{ngModule:GamificationModule,providers:[GamificationService,{provide:"config",useValue:config}]}},GamificationModule.forChild=function(config){return{ngModule:GamificationModule,providers:[GamificationService,{provide:"config",useValue:config}]}},GamificationModule.decorators=[{type:core.NgModule,args:[{declarations:[],exports:[]}]}],GamificationModule.ctorParameters=function(){return[]},GamificationModule}();exports.GamificationService=GamificationService,exports.GamificationModule=GamificationModule,Object.defineProperty(exports,"__esModule",{value:!0})});